//+------------------------------------------------------------------
//|                                                     T3 taotra.mq4 
//|                                                            mladen 
//|                                                                  
//+------------------------------------------------------------------
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"

#property indicator_separate_window
#property indicator_buffers 8

//
//
//
//
//

extern int    T3Period_1  = 3;
extern int    T3Period_2  = 5;
extern int    T3Period_3  = 8;
extern int    T3Period_4  = 13;
extern int    T3Period_5  = 21;
extern int    T3Period_6  = 34;
extern int    T3Period_7  = 55;
extern int    T3Period_8  = 89;
extern int    T3Price     = PRICE_CLOSE;
extern double T3Hot       = 0.7;
extern bool   T3Original  = false;
extern int    LinesWidth  = 1;
extern color  ColorFast   = LimeGreen;
extern color  ColorMiddle = Gold;
extern color  ColorSlow   = PaleVioletRed;

//
//
//
//
//

double t31[];
double t32[];
double t33[];
double t34[];
double t35[];
double t36[];
double t37[];
double t38[];

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int init()
{
   IndicatorBuffers(8);
      SetIndexBuffer(0,t31);
      SetIndexBuffer(1,t32);
      SetIndexBuffer(2,t33);
      SetIndexBuffer(3,t34);
      SetIndexBuffer(4,t35);
      SetIndexBuffer(5,t36);
      SetIndexBuffer(6,t37);
      SetIndexBuffer(7,t38);
   return(0);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

double work[][2];

int start()
{
   int i,limit,counted_bars=IndicatorCounted();

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
           limit=MathMin(Bars-counted_bars,Bars-1);

           //
           //
           //
           //
           //
           
           static bool colorsSet=false;
                  if (!colorsSet)
                  {
                     colorsSet = true; for (i=0;i<8; i++)
                        if (i<4)
                              SetIndexStyle(i,NULL,NULL,LinesWidth,gradientColor(i  ,4,ColorFast,ColorMiddle));
                        else  SetIndexStyle(i,NULL,NULL,LinesWidth,gradientColor(i-4,4,ColorMiddle,ColorSlow));
                  }
   //
   //
   //
   //
   //

      for(i=limit; i>=0; i--)
      {
         double price = iMA(NULL,0,1,0,MODE_SMA,T3Price,i);
            if (T3Period_1>0) t31[i] = iT3(price,T3Period_1,T3Hot,T3Original,i,0);
            if (T3Period_2>0) t32[i] = iT3(price,T3Period_2,T3Hot,T3Original,i,1);
            if (T3Period_3>0) t33[i] = iT3(price,T3Period_3,T3Hot,T3Original,i,2);
            if (T3Period_4>0) t34[i] = iT3(price,T3Period_4,T3Hot,T3Original,i,3);
            if (T3Period_5>0) t35[i] = iT3(price,T3Period_5,T3Hot,T3Original,i,4);
            if (T3Period_6>0) t36[i] = iT3(price,T3Period_6,T3Hot,T3Original,i,5);
            if (T3Period_7>0) t37[i] = iT3(price,T3Period_7,T3Hot,T3Original,i,6);
            if (T3Period_8>0) t38[i] = iT3(price,T3Period_8,T3Hot,T3Original,i,7);
      }
      return(0);
}

//+------------------------------------------------------------------
//|
//+------------------------------------------------------------------
//
//
//
//
//

double workT3[][56];
double workT3Coeffs[][6];
#define _period 0
#define _c1     1
#define _c2     2
#define _c3     3
#define _c4     4
#define _alpha  5
#define _atr    6

//
//
//
//
//

double iT3(double price, double period, double hot, bool original, int i, int forInstance=0)
{
   int r      = Bars-i-1;
   int buffer = forInstance*7;

   //
   //
   //
   //
   //
   
      if (ArrayRange(workT3,0) !=Bars)                  ArrayResize(workT3,Bars);
      if (ArrayRange(workT3Coeffs,0) < (forInstance+1)) ArrayResize(workT3Coeffs,forInstance+1);
   
   //
   //
   //
   //
   //
   
      if (workT3Coeffs[forInstance][_period] != period)
      {
        workT3Coeffs[forInstance][_period] = period;
           double a = hot;
               workT3Coeffs[forInstance][_c1] = -a*a*a;
               workT3Coeffs[forInstance][_c2] = 3*a*a+3*a*a*a;
               workT3Coeffs[forInstance][_c3] = -6*a*a-3*a-3*a*a*a;
               workT3Coeffs[forInstance][_c4] = 1+3*a+a*a*a+3*a*a;
               if (original)
                    workT3Coeffs[forInstance][_alpha] = 2.0/(1.0 + period);
               else workT3Coeffs[forInstance][_alpha] = 2.0/(2.0 + (period-1.0)/2.0);
      }
   
   //
   //
   //
   //
   //
   
   if (r == 0)
      {
         workT3[r][0+buffer] = price;
         workT3[r][1+buffer] = price;
         workT3[r][2+buffer] = price;
         workT3[r][3+buffer] = price;
         workT3[r][4+buffer] = price;
         workT3[r][5+buffer] = price;
      }
   else
      {
         workT3[r][0+buffer] = workT3[r-1][0+buffer]+workT3Coeffs[forInstance][_alpha]*(price              -workT3[r-1][0+buffer]);
         workT3[r][1+buffer] = workT3[r-1][1+buffer]+workT3Coeffs[forInstance][_alpha]*(workT3[r][0+buffer]-workT3[r-1][1+buffer]);
         workT3[r][2+buffer] = workT3[r-1][2+buffer]+workT3Coeffs[forInstance][_alpha]*(workT3[r][1+buffer]-workT3[r-1][2+buffer]);
         workT3[r][3+buffer] = workT3[r-1][3+buffer]+workT3Coeffs[forInstance][_alpha]*(workT3[r][2+buffer]-workT3[r-1][3+buffer]);
         workT3[r][4+buffer] = workT3[r-1][4+buffer]+workT3Coeffs[forInstance][_alpha]*(workT3[r][3+buffer]-workT3[r-1][4+buffer]);
         workT3[r][5+buffer] = workT3[r-1][5+buffer]+workT3Coeffs[forInstance][_alpha]*(workT3[r][4+buffer]-workT3[r-1][5+buffer]);
      }

   //
   //
   //
   //
   //
   
   return(workT3Coeffs[forInstance][_c1]*workT3[r][5+buffer] + 
          workT3Coeffs[forInstance][_c2]*workT3[r][4+buffer] + 
          workT3Coeffs[forInstance][_c3]*workT3[r][3+buffer] + 
          workT3Coeffs[forInstance][_c4]*workT3[r][2+buffer]);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

color gradientColor(int step, int totalSteps, color from, color to)
{
   color newBlue  = getColor(step,totalSteps,(from & 0XFF0000)>>16,(to & 0XFF0000)>>16)<<16;
   color newGreen = getColor(step,totalSteps,(from & 0X00FF00)>> 8,(to & 0X00FF00)>> 8) <<8;
   color newRed   = getColor(step,totalSteps,(from & 0X0000FF)    ,(to & 0X0000FF)    )    ;
   return(newBlue+newGreen+newRed);
}
color getColor(int stepNo, int totalSteps, color from, color to)
{
   double step = (from-to)/(totalSteps-1.0);
   return(MathRound(from-step*stepNo));
}

